package com.yaohun.gameranking;

import com.io.yutian.pixelliveplugin.PixelLiveAPI;
import com.yaohun.gameranking.api.RankingAPI;
import com.yaohun.gameranking.data.UserData;
import com.yaohun.gameranking.manager.RankManager;
import com.yaohun.gameranking.manager.UserManager;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.*;

public class GameRanking extends JavaPlugin {

    private static GameRanking instance;
    private static RankManager rankManager;
    private static UserManager userManager;

    @Override
    public void onEnable() {
        instance = this;
        saveDefaultConfig();
        rankManager = new RankManager(getConfig());
        userManager = new UserManager();
        //Bukkit.getPluginManager().registerEvents(new KeepEntitiesOnDeath(), this);
    }

    @Override
    public void onDisable() {
        rankManager.SaveRankingData(getConfig());
        userManager.SaveUserData();
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (label.equalsIgnoreCase("gamerank")) {
            if(args.length == 0){
                sender.sendMessage("/gamerank [类型] [时间] - 查看排行榜");
                return true;
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("save")){
                userManager.SaveUserData();
                rankManager.SaveRankingData(getConfig());
                sender.sendMessage("数据保存成功.");
                return true;
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("show")){
                Player player = (Player) sender;
                PixelLiveAPI.enableRankHud(player);
                sender.sendMessage("排行HUD显示: 开启");
                return true;
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("hide")){
                Player player = (Player) sender;
                PixelLiveAPI.disableRankHud(player);
                sender.sendMessage("排行HUD显示: 关闭");
                return true;
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("test")){
                Player player = (Player) sender;
                PixelLiveAPI.setRankData(player,1,"https://p3.douyinpic.com/aweme/100x100/aweme-avatar/tos-cn-i-0813c001_okAAZknl8ANJHBehA90kACfAQOSIQNAbgmgkYD.jpeg?from=3067671334",33);
                PixelLiveAPI.setRankData(player,2,"https://p26.douyinpic.com/aweme/100x100/aweme-avatar/tos-cn-i-0813_owAAbniIEAgz8HcfNXiCiHDQMH4YzAAdBCSeA3.jpeg?from=3067671334",26);
                PixelLiveAPI.setRankData(player,3,"https://p26.douyinpic.com/aweme/100x100/aweme-avatar/tos-cn-avt-0015_92c143b72684a5f65ab27987a9985fc9.jpeg?from=3067671334",13);
                sender.sendMessage("排行数据设置成功");
                return true;
            }
            if(args.length >= 1){
                String dataKey = args[0];
                String timeKey = rankManager.getTime("yyyy-MM-dd");
                if(args.length == 2) {
                    timeKey = args[1];
                }
                LinkedHashMap<String ,Integer> linkedHashMap;
                if(timeKey.equalsIgnoreCase("Week")){
                    linkedHashMap = RankingAPI.getRankingWeeklyData(dataKey);
                } else {
                    linkedHashMap = RankingAPI.getRankingData(timeKey, dataKey);
                }
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage(" ");
                sender.sendMessage("§e§l★ §a保卫小麦-"+dataKey+"排行榜 §7(实时更新数据)");
                int rank = 1;
                for (String name : linkedHashMap.keySet()){
                    if(rank > 10){break;}
                    sender.sendMessage("§a§l★ §7第 §e" + rank + " §7名: §e" + name + " §7( §6" + linkedHashMap.get(name)+"分 §7)");
                    rank++;
                }
                sender.sendMessage(" ");
            }
        }
        return false;
    }

    public static GameRanking inst() {
        return instance;
    }

    public static RankManager getRankManager() {
        return rankManager;
    }

    public static UserManager getUserManager() {
        return userManager;
    }
}
