package com.yaohun.gameranking.data;

import jsonrank.JSONArray;
import jsonrank.JSONObject;
import org.bukkit.configuration.file.FileConfiguration;

public class UserJson {

    private String secUid;
    private String nickName;
    private String shortId;
    private String avatarUrl;
    private JSONObject dataObject;

    public UserJson(String jsonObjectString){
        this.dataObject = new JSONObject(jsonObjectString);
        this.secUid = dataObject.getString("secUid");
        this.nickName = dataObject.getString("nickName");
        this.shortId = dataObject.getString("shortId");
        JSONArray jsonArray = dataObject.getJSONObject("AvatarThumb").getJSONArray("urlListList");
        this.avatarUrl = jsonArray.getString(0);
    }

    public UserJson(FileConfiguration yml,String nickName){
        this.nickName = nickName;
        this.secUid = yml.getString(nickName+".secUid");
        this.shortId = yml.getString(nickName+".shortId");
        this.avatarUrl = yml.getString(nickName+".avatarUrl");
        String dataObjectString = yml.getString(nickName+".dataObject");
        this.dataObject = new JSONObject(dataObjectString);
    }

    public String getSecUid() {
        return secUid;
    }

    public String getNickName() {
        return nickName;
    }

    public String getShortId() {
        return shortId;
    }

    public String getAvatarUrl() {
        return avatarUrl;
    }

    public JSONObject getDataObject() {
        return dataObject;
    }

    public void setDataObject(JSONObject dataObject) {
        this.dataObject = dataObject;
        if(!dataObject.getString("nickName").equalsIgnoreCase(nickName)){
            this.nickName = dataObject.getString("nickName");
        }
    }
}
